import {RouterModule} from "@angular/router";
import {CUSTOM_ELEMENTS_SCHEMA, NgModule} from '@angular/core';
import { CommonModule } from '@angular/common';
import { NgxEchartsModule } from "ngx-echarts";
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {NgZorroAntdModule,NZ_I18N,zh_CN} from 'ng-zorro-antd';
import {AlarmListComponent} from './alarm/alarm-list/alarm-list.component';
import {AlarmLogComponent} from './alarm/alarm-log/alarm-log.component';
import {AlarmManageComponent} from './alarm/alarm-manage/alarm-manage.component';
import {AlarmSetComponent} from './alarm/alarm-set/alarm-set.component';
import {SendLogComponent} from './alarm/modal/send-log/send-log.component';
import {NowAlarmComponent} from './alarm/now-alarm/now-alarm.component';
import {SendSetComponent} from './alarm/send-set/send-set.component';
import {BasicDetailComponent} from './overAll/basic/basic-detail/basic-detail.component';
import {BasicComponent} from './overAll/basic/basic.component';
import {MonitorComponent} from './overAll/monitor/monitor.component';
import {SecurityComponent} from './overAll/security/security.component';
import {AuditComponent} from './system/audit/audit.component';
import {ExamineComponent} from './system/examine/examine.component';
import {GroupComponent} from './system/group/group.component';
import {PowerComponent} from './system/power/power.component';
import {BasiCheckComponent} from './modal/basi-check/basi-check.component';
import {BasicEditComponent} from './modal/basic-edit/basic-edit.component';
import {BasicKeyComponent} from './modal/basic-key/basic-key.component';
import {CreateGroupComponent} from './modal/create-group/create-group.component';
import {NewTypeComponent} from './modal/new-type/new-type.component';
import {WarnListComponent} from './modal/warn-list/warn-list.component';
import {JhiMainComponent, NavbarComponent, SidebarComponent} from './layouts';
import {OverAllService} from './overAll/overAll.service';
import {SystemService} from './system/system.service';
import {AlarmService} from './alarm/alarm.service';
import {PauseComponent} from './modal/pause/pause.component';
import {AlarmModalComponent} from './modal/alarm-modal/alarm-modal.component';
import {UserComponent} from './system/modal/user/user.component';
import {GroupModalComponent} from './system/modal/group-modal/group-modal.component';
import {RoleComponent} from './system/modal/role/role.component';
import {NeTopologyComponent} from './netTopology/ne-topology/ne-topology.component';
import {FlowTrendComponent} from './netTopology/flow-trend/flow-trend.component';
import {TopologyService} from './netTopology/topology.service';
import {AnalysisService} from './analysis/analysis.service';
import {OperationService} from './operation/operation.service';
import {SmartService} from './smart/smart.service';
import {WorkService} from './work/work.service';
import {AlarmGroupComponent} from './alarm/modal/alarm-group/alarm-group.component';
import {MediaTypeComponent} from './alarm/modal/media-type/media-type.component';

@NgModule({
    imports: [
        RouterModule,
        CommonModule,
        NgxEchartsModule,
        FormsModule,
        ReactiveFormsModule,
        NgZorroAntdModule.forRoot()
    ],
    declarations: [
        JhiMainComponent,
        NavbarComponent,
        SidebarComponent,
        AlarmListComponent,
        AlarmLogComponent,
        AlarmManageComponent,
        AlarmSetComponent,
        SendLogComponent,
        NowAlarmComponent,
        SendSetComponent,
        BasicDetailComponent,
        BasicComponent,
        MonitorComponent,
        SecurityComponent,
        AuditComponent,
        ExamineComponent,
        GroupComponent,
        PowerComponent,
        BasiCheckComponent,
        BasicEditComponent,
        BasicKeyComponent,
        CreateGroupComponent,
        NewTypeComponent,
        WarnListComponent,
        PauseComponent,
        AlarmModalComponent,
        UserComponent,
        GroupModalComponent,
        RoleComponent,
        NeTopologyComponent,
        FlowTrendComponent,
        AlarmGroupComponent,
        MediaTypeComponent
    ],
    providers:[
        OverAllService,
        SystemService,
        AlarmService,
        TopologyService,
        AnalysisService,
        OperationService,
        SmartService,
        WorkService,
        { provide: NZ_I18N,
            useValue: zh_CN }
    ],
    exports:[
        BasiCheckComponent,
        BasicEditComponent,
        BasicKeyComponent,
        CreateGroupComponent,
        NewTypeComponent,
        WarnListComponent,
        PauseComponent
    ],
    schemas: [ CUSTOM_ELEMENTS_SCHEMA ],
})
export class AppMainModule { }
